import * as mc from "@minecraft/server";

mc.world.beforeEvents.playerBreakBlock.subscribe( data => {
    const block = data.block;
    const loc = block.location;
    const player = data.player;
    const raycast = player.getBlockFromViewDirection();
    const loc2 = raycast?.block.location;
    const fLoc = raycast?.faceLocation;
    let bBase = null;
    let bAdd = null;
    let half = null;
    let change = false;
    if (raycast && loc.x == loc2.x && loc.y == loc2.y && loc.z == loc2.z) {
    if (block.typeId.includes('double_cut_copper_slab')) {
    bBase = block.typeId.slice(0, -22);
    bAdd = "cut_copper_slab";
    change = true;
    } else if (block.typeId.endsWith('_double_slab')) {
    bBase = block.typeId.slice(0, -11);
    bAdd = "slab";
    change = true;
    }
    if (fLoc.y <= 0.5) {
    half = "top"
    } else {
    half = "bottom"
    }
    if (change == true) {
    let iBase = block.getItemStack();
    data.cancel = true;
    player.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} ${bBase}${bAdd} ["minecraft:vertical_half"="${half}"]`);
    mc.system.run(() => {
    player.dimension.spawnItem(iBase, loc);
    let item = data.itemStack;
    let durability = item?.getComponent("durability");
    if (item && durability) {
    const equip = player.getComponent('equippable');
    let maxDurability = durability.maxDurability;
    durability.damage += 1;
    let damage = durability.damage;
       if (damage < maxDurability) {
       equip.setEquipment(mc.EquipmentSlot.Mainhand, item);
        } else {
       equip.setEquipment(mc.EquipmentSlot.Mainhand, undefined);
           }}
       });
    }}
});